wdttb: Wdttb_v4_5

| wdttb Xilinx SDK Drivers API Documentation

- Overview
- Data Structures
- APIs
- File List
- Examples

Data Structures | Macros | Enumerations | Functions
Wdttb_v4_5

## Data Structures
struct | XWdtTb_Config
| This typedef contains configuration information for the device. More...
struct | XWdtTb
| The XWdtTb driver instance data. More...

## Macros
#define | XWDTTB_HW_H_
| Prevent circular inclusions by using protection macros. More...

## Enumerations
enum | XWdtTb_Event { XWDTTB_NO_BAD_EVENT = 0, XWDTTB_RS_KICK_EVENT, XWDTTB_TSR_MM_EVENT, XWDTTB_SEC_WIN_EVENT }
| This typedef contains enumeration of different events in basic mode. More...

## Functions
s32 | XWdtTb_CfgInitialize (XWdtTb *InstancePtr, const XWdtTb_Config *CfgPtr, UINTPTR EffectiveAddr)
| This function initializes the AXI Timebase Watchdog Timer core. More...
s32 | XWdtTb_Initialize (XWdtTb *InstancePtr, u16 DeviceId)
| Initialize a specific legacy/window watchdog timer/timebase instance/driver. More...
void | XWdtTb_Start (XWdtTb *InstancePtr)
| This function starts the legacy or window watchdog timer. More...
s32 | XWdtTb_Stop (XWdtTb *InstancePtr)
| This function disables the legacy or window watchdog timer. More...
u32 | XWdtTb_IsWdtExpired (const XWdtTb *InstancePtr)
| This function checks if the legacy watchdog timer has expired or window watchdog timer either in second window or not in second window. More...
u32 | XWdtTb_IsGenericWdtFWExpired (const XWdtTb *InstancePtr)
| This function checks if the Generic watchdog timer has First window expired or not. More...
void | XWdtTb_RestartWdt (const XWdtTb *InstancePtr)
| This function restarts the legacy or window watchdog timer. More...
void | XWdtTb_AlwaysEnable (const XWdtTb *InstancePtr)
| This function keeps Window Watchdog Timer always enabled. More...
void | XWdtTb_ClearLastEvent (const XWdtTb *InstancePtr)
| This function clears event(s) that present after system reset. More...
void | XWdtTb_ClearResetPending (const XWdtTb *InstancePtr)
| This function clears the window watchdog reset pending. More...
void | XWdtTb_IntrClear (const XWdtTb *InstancePtr)
| This function clears window watchdog timer interrupt (WINT) bit. More...
void | XWdtTb_SetByteCount (const XWdtTb *InstancePtr, u32 ByteCount)
| This function sets byte count to determine the interrupt assertion point in the second window configuration. More...
u32 | XWdtTb_GetByteCount (const XWdtTb *InstancePtr)
| This function provides byte count value of the selected byte count in the second window configuration. More...
void | XWdtTb_SetByteSegment (const XWdtTb *InstancePtr, u32 ByteSegment)
| This function sets byte segment selection to determine the interrupt assertion point in the second window configuration. More...
u32 | XWdtTb_GetByteSegment (const XWdtTb *InstancePtr)
| This function provides byte segment selection in the second window configuration. More...
void | XWdtTb_EnableSst (const XWdtTb *InstancePtr)
| This function enables Second Sequence Timer (SST) function. More...
void | XWdtTb_DisableSst (const XWdtTb *InstancePtr)
| This function disables Second Sequence Timer (SST) function. More...
void | XWdtTb_EnablePsm (const XWdtTb *InstancePtr)
| This function enables Program Sequence Monitor (PSM) function. More...
void | XWdtTb_DisablePsm (const XWdtTb *InstancePtr)
| This function disables Program Sequence Monitor (PSM) function. More...
void | XWdtTb_EnableFailCounter (XWdtTb *InstancePtr)
| This function enables Fail Counter (FC) function. More...
void | XWdtTb_DisableFailCounter (XWdtTb *InstancePtr)
| This function disables Fail Counter (FC) function. More...
void | XWdtTb_EnableExtraProtection (const XWdtTb *InstancePtr)
| This function provides extra safeguard against unintentional clear of WEN bit. More...
void | XWdtTb_DisableExtraProtection (const XWdtTb *InstancePtr)
| This function enables unintentional clear of WEN bit. More...
void | XWdtTb_SetWindowCount (const XWdtTb *InstancePtr, u32 FirstWinCount, u32 SecondWinCount)
| This function sets the count value for the first and second window. More...
u32 | XWdtTb_ProgramWDTWidth (const XWdtTb *InstancePtr, u32 width)
| This function programs the width of Watchdog Timer. More...
XWdtTb_Config * | XWdtTb_LookupConfig (u16 DeviceId)
| This function returns a reference to an XWdtTb_Config structure based on the core id, DeviceId. More...
s32 | XWdtTb_SelfTest (const XWdtTb *InstancePtr)
| This function runs a self-test on the timebase or window if enabled. More...

## Register offsets for the WWDT core with Generic & windowing
feature with basic mode. Each register is 32 bits.
#define | XWT_MWR_OFFSET 0x0000U
| Master Write Control Register Offset. More...
#define | XWT_ESR_OFFSET 0x0004U
| Enable & Status Register Offset. More...
#define | XWT_FCR_OFFSET 0x0008U
| Function Control Register Register Offset. More...
#define | XWT_FWR_OFFSET 0x000CU
| First Window Configuration Register Offset. More...
#define | XWT_SWR_OFFSET 0x0010U
| Second Window Configuration Register Offset. More...
#define | XWT_TSR0_WWDT_OFFSET 0x0018U
| Task Signature Register 0 Offset for WWDT. More...
#define | XWT_TSR1_WWDT_OFFSET 0x001CU
| Task Signature Register 1 Offset for WWDT. More...
#define | XWT_STR_WWDT_OFFSET 0x0020U
| Second Sequence Timer Register Offset for WWDT. More...
#define | XWT_TSR0_OFFSET 0x0014U
| Task Signature Register 0 Offset. More...
#define | XWT_TSR1_OFFSET 0x0018U
| Task Signature Register 1 Offset. More...
#define | XWT_STR_OFFSET 0x001CU
| Second Sequence Timer Register Offset. More...
#define | XWT_SSTWR_OFFSET 0x0014U
| Second Sequence Timer Window Configuration Register Offset. More...
#define | XWT_TFR_OFFSET 0x0024U
| Token Feedback Register Offset. More...
#define | XWT_TRR_OFFSET 0x0028U
| Token Response Register offset. More...
#define | XWT_IENR_OFFSET 0x002CU
| Interrupt Enable Register Offset. More...
#define | XWT_IDR_OFFSET 0x0030U
| Interrupt Disable Register Offset. More...
#define | XWT_IMR_OFFSET 0x0034U
| Interrupt Mask Register Offset. More...
#define | XWT_GWRR_OFFSET 0x1000U
| Generic Watchdog Refresh Register Offset. More...
#define | XWT_GWCSR_OFFSET 0x2000U
| Generic Watchdog Control and Status Register Offset. More...
#define | XWT_GWOR_OFFSET 0x2008U
| Generic Watchdog Offset Register Offset. More...
#define | XWT_GWCVR0_OFFSET 0x2010U
| Generic Watchdog Compare Value Register 0 Offset. More...
#define | XWT_GWCVR1_OFFSET 0x2014U
| Generic Watchdog Compare Value Register 1 Offset. More...
#define | XWT_GW_WR_OFFSET 0x2FD0U
| Generic Watchdog Warm Reset Register Offset. More...

## Register offsets for the AXI Timebase WDT core. Each register is 32
bits.
#define | XWT_TWCSR0_OFFSET 0x00U
| Control/Status Register 0 Offset. More...
#define | XWT_TWCSR1_OFFSET 0x04U
| Control/Status Register 1 Offset. More...
#define | XWT_TBR_OFFSET 0x08U
| Timebase Register Offset. More...

## Control/Status Register 0 bits
#define | XWT_CSR0_WRS_MASK 0x00000008U
| Reset status Mask. More...
#define | XWT_CSR0_WDS_MASK 0x00000004U
| Timer state Mask. More...
#define | XWT_CSR0_EWDT1_MASK 0x00000002U
| Enable bit 1 Mask. More...

## Control/Status Register 0/1 bits
#define | XWT_CSRX_EWDT2_MASK 0x00000001U
| Enable bit 2 Mask. More...

## Master Write Control bits
#define | XWT_MWR_AEN_MASK 0x00000002U
| Always Enable Mask. More...
#define | XWT_MWR_MWC_MASK 0x00000001U
| Master Write Control Mask. More...

## Enable & Status Register bits
#define | XWT_ESR_LBE_MASK 0x07000000U
| Last Bad Event Mask. More...
#define | XWT_ESR_FCV_MASK 0x00700000U
| Fail Counter Value Mask. More...
#define | XWT_ESR_WRP_MASK 0x00020000U
| Watchdog Reset Pending Mask. More...
#define | XWT_ESR_WINT_MASK 0x00010000U
| Watchdog Interrupt Mask. More...
#define | XWT_ESR_WSW_MASK 0x00000100U
| Watchdog Second Window Mask. More...
#define | XWT_ESR_WCFG_MASK 0x00000002U
| Wrong Configuration Mask. More...
#define | XWT_ESR_WEN_MASK 0x00000001U
| Window WDT Enable Mask. More...
#define | XWT_ESR_LBE_SHIFT 24U
| Last Bad Event Shift. More...
#define | XWT_ESR_FCV_SHIFT 20U
| Fail Counter Value Shift. More...
#define | XWT_ESR_WRP_SHIFT 17U
| Watchdog Reset Pending Shift. More...
#define | XWT_ESR_WINT_SHIFT 16U
| Watchdog Interrupt Shift. More...
#define | XWT_ESR_WSW_SHIFT 8U
| Watchdog Second Window Shift. More...
#define | XWT_ESR_WCFG_SHIFT 1U
| Wrong Configuration Shift. More...

## Function Control Register bits
#define | XWT_FCR_SBC_MASK 0x0000FF00U
| Selected Byte Count Mask. More...
#define | XWT_FCR_BSS_MASK 0x000000C0U
| Byte Segment Selection Mask. More...
#define | XWT_FCR_SSTE_MASK 0x00000010U
| Second Sequence Timer Enable Mask. More...
#define | XWT_FCR_PSME_MASK 0x00000008U
| Program Sequence Monitor Enable Mask. More...
#define | XWT_FCR_FCE_MASK 0x00000004U
| Fail Counter Enable Mask. More...
#define | XWT_FCR_WM_MASK 0x00000002U
| Window WDT Mode Mask. More...
#define | XWT_FCR_WDP_MASK 0x00000001U
| Window WDT Disable Protection Mask. More...
#define | XWT_FCR_SBC_SHIFT 8U
| Selected Byte Count Shift. More...
#define | XWT_FCR_BSS_SHIFT 6U
| Byte Segment Selection Shift. More...
#define | XWT_FCR_SSTE_SHIFT 4U
| Second Sequence Timer Enable Shift. More...
#define | XWT_FCR_WM_SHIFT 1U
| Window WDT Mode Shift. More...

## Generic Watchdog Control and Status Register bits
#define | XWT_GWCSR_GWEN_MASK 0x00000001U
| Watchdog enable bit. More...
#define | XWT_GWCSR_GWS1_MASK 0x00000002U
| Generic_wdt_interrupt bit. More...
#define | XWT_GWCSR_GWS2_MASK 0x00000004U
| Generic_wdt_reset bit. More...

## Register access macro definition
#define | XWdtTb_In32 Xil_In32
| Input Operations. More...
#define | XWdtTb_Out32 Xil_Out32
| Output Operations. More...
#define | XWdtTb_ReadReg(BaseAddress, RegOffset) XWdtTb_In32((BaseAddress) + ((u32)RegOffset))
| Read from the specified WdtTb core's register. More...
#define | XWdtTb_WriteReg(BaseAddress, RegOffset, RegisterValue) XWdtTb_Out32((BaseAddress) + ((u32)RegOffset), (u32)(RegisterValue))
| Write to the specified WdtTb core's register. More...

## Macro Definition Documentation

#define XWDTTB_HW_H_

Prevent circular inclusions by using protection macros.

#define XWdtTb_In32 Xil_In32

Input Operations.

#define XWdtTb_Out32 Xil_Out32

Output Operations.

#define XWdtTb_ReadReg | ( |  | BaseAddress,
|  |  | RegOffset
| ) |  | XWdtTb_In32((BaseAddress) + ((u32)RegOffset))

Read from the specified WdtTb core's register.

Parameters

  BaseAddress | contains the base address of the core.
  RegOffset | contains the offset from the 1st register of the core to select the specific register.

Returns
  The value read from the register.

Note
  C-Style signature: u32 XWdtTb_ReadReg(u32 BaseAddress, u32 RegOffset);

Referenced by WdtTbExample(), WdtTbIntrExample(), XWdtTb_AlwaysEnable(), XWdtTb_ClearLastEvent(), XWdtTb_ClearResetPending(), XWdtTb_DisableExtraProtection(), XWdtTb_DisableFailCounter(), XWdtTb_DisablePsm(), XWdtTb_DisableSst(), XWdtTb_EnableExtraProtection(), XWdtTb_EnableFailCounter(), XWdtTb_EnablePsm(), XWdtTb_EnableSst(), XWdtTb_GetByteCount(), XWdtTb_GetByteSegment(), XWdtTb_IntrClear(), XWdtTb_IsGenericWdtFWExpired(), XWdtTb_IsWdtExpired(), XWdtTb_LowLevelExample(), XWdtTb_RestartWdt(), XWdtTb_SelfTest(), XWdtTb_SetByteCount(), and XWdtTb_SetByteSegment().

#define XWdtTb_WriteReg | ( |  | BaseAddress,
|  |  | RegOffset,
|  |  | RegisterValue
| ) |  | XWdtTb_Out32((BaseAddress) + ((u32)RegOffset), (u32)(RegisterValue))

Write to the specified WdtTb core's register.

Parameters

  BaseAddress | contains the base address of the core.
  RegOffset | contains the offset from the 1st register of the core to select the specific register.
  RegisterValue | is the value to be written to the register.

Returns
  None.

Note
  C-Style signature: void XWdtTb_WriteReg(u32 BaseAddress, u32 RegOffset, u32 RegisterValue);

Referenced by XWdtTb_AlwaysEnable(), XWdtTb_CfgInitialize(), XWdtTb_ClearLastEvent(), XWdtTb_ClearResetPending(), XWdtTb_DisableExtraProtection(), XWdtTb_DisableFailCounter(), XWdtTb_DisablePsm(), XWdtTb_DisableSst(), XWdtTb_EnableExtraProtection(), XWdtTb_EnableFailCounter(), XWdtTb_EnablePsm(), XWdtTb_EnableSst(), XWdtTb_IntrClear(), XWdtTb_LowLevelExample(), XWdtTb_ProgramWDTWidth(), XWdtTb_RestartWdt(), XWdtTb_SelfTest(), XWdtTb_SetByteCount(), XWdtTb_SetByteSegment(), and XWdtTb_SetWindowCount().

#define XWT_CSR0_EWDT1_MASK 0x00000002U

Enable bit 1 Mask.

Referenced by XWdtTb_LowLevelExample().

#define XWT_CSR0_WDS_MASK 0x00000004U

Timer state Mask.

Referenced by XWdtTb_IsWdtExpired(), XWdtTb_LowLevelExample(), and XWdtTb_RestartWdt().

#define XWT_CSR0_WRS_MASK 0x00000008U

Reset status Mask.

Referenced by WdtTbExample(), WdtTbIntrExample(), XWdtTb_IsWdtExpired(), XWdtTb_LowLevelExample(), and XWdtTb_RestartWdt().

#define XWT_CSRX_EWDT2_MASK 0x00000001U

Enable bit 2 Mask.

Referenced by XWdtTb_LowLevelExample().

#define XWT_ESR_FCV_MASK 0x00700000U

Fail Counter Value Mask.

#define XWT_ESR_FCV_SHIFT 20U

Fail Counter Value Shift.

#define XWT_ESR_LBE_MASK 0x07000000U

Last Bad Event Mask.

Referenced by XWdtTb_ClearLastEvent(), and XWdtTb_SelfTest().

#define XWT_ESR_LBE_SHIFT 24U

Last Bad Event Shift.

Referenced by XWdtTb_SelfTest().

#define XWT_ESR_OFFSET 0x0004U

Enable & Status Register Offset.

Referenced by XWdtTb_ClearLastEvent(), XWdtTb_ClearResetPending(), XWdtTb_IntrClear(), XWdtTb_IsWdtExpired(), XWdtTb_RestartWdt(), and XWdtTb_SelfTest().

#define XWT_ESR_WCFG_MASK 0x00000002U

Wrong Configuration Mask.

#define XWT_ESR_WCFG_SHIFT 1U

Wrong Configuration Shift.

#define XWT_ESR_WEN_MASK 0x00000001U

Window WDT Enable Mask.

Referenced by XWdtTb_SelfTest().

#define XWT_ESR_WINT_MASK 0x00010000U

Watchdog Interrupt Mask.

Referenced by XWdtTb_IntrClear().

#define XWT_ESR_WINT_SHIFT 16U

Watchdog Interrupt Shift.

#define XWT_ESR_WRP_MASK 0x00020000U

Watchdog Reset Pending Mask.

Referenced by XWdtTb_ClearResetPending().

#define XWT_ESR_WRP_SHIFT 17U

Watchdog Reset Pending Shift.

#define XWT_ESR_WSW_MASK 0x00000100U

Watchdog Second Window Mask.

Referenced by XWdtTb_ClearLastEvent(), XWdtTb_IntrClear(), XWdtTb_IsWdtExpired(), XWdtTb_RestartWdt(), and XWdtTb_SelfTest().

#define XWT_ESR_WSW_SHIFT 8U

Watchdog Second Window Shift.

Referenced by XWdtTb_ClearLastEvent(), XWdtTb_IntrClear(), and XWdtTb_IsWdtExpired().

#define XWT_FCR_BSS_MASK 0x000000C0U

Byte Segment Selection Mask.

Referenced by XWdtTb_GetByteSegment(), and XWdtTb_SetByteSegment().

#define XWT_FCR_BSS_SHIFT 6U

Byte Segment Selection Shift.

Referenced by XWdtTb_GetByteSegment(), and XWdtTb_SetByteSegment().

#define XWT_FCR_FCE_MASK 0x00000004U

Fail Counter Enable Mask.

Referenced by XWdtTb_DisableFailCounter(), and XWdtTb_EnableFailCounter().

#define XWT_FCR_OFFSET 0x0008U

Function Control Register Register Offset.

Referenced by XWdtTb_DisableExtraProtection(), XWdtTb_DisableFailCounter(), XWdtTb_DisablePsm(), XWdtTb_DisableSst(), XWdtTb_EnableExtraProtection(), XWdtTb_EnableFailCounter(), XWdtTb_EnablePsm(), XWdtTb_EnableSst(), XWdtTb_GetByteCount(), XWdtTb_GetByteSegment(), XWdtTb_SetByteCount(), and XWdtTb_SetByteSegment().

#define XWT_FCR_PSME_MASK 0x00000008U

Program Sequence Monitor Enable Mask.

Referenced by XWdtTb_DisablePsm(), and XWdtTb_EnablePsm().

#define XWT_FCR_SBC_MASK 0x0000FF00U

Selected Byte Count Mask.

Referenced by XWdtTb_GetByteCount(), and XWdtTb_SetByteCount().

#define XWT_FCR_SBC_SHIFT 8U

Selected Byte Count Shift.

Referenced by XWdtTb_GetByteCount(), and XWdtTb_SetByteCount().

#define XWT_FCR_SSTE_MASK 0x00000010U

Second Sequence Timer Enable Mask.

Referenced by XWdtTb_DisableSst(), and XWdtTb_EnableSst().

#define XWT_FCR_SSTE_SHIFT 4U

Second Sequence Timer Enable Shift.

#define XWT_FCR_WDP_MASK 0x00000001U

Window WDT Disable Protection Mask.

Referenced by XWdtTb_DisableExtraProtection(), and XWdtTb_EnableExtraProtection().

#define XWT_FCR_WM_MASK 0x00000002U

Window WDT Mode Mask.

#define XWT_FCR_WM_SHIFT 1U

Window WDT Mode Shift.

#define XWT_FWR_OFFSET 0x000CU

First Window Configuration Register Offset.

Referenced by XWdtTb_SelfTest(), and XWdtTb_SetWindowCount().

#define XWT_GW_WR_OFFSET 0x2FD0U

Generic Watchdog Warm Reset Register Offset.

Referenced by XWdtTb_CfgInitialize().

#define XWT_GWCSR_GWEN_MASK 0x00000001U

Watchdog enable bit.

Referenced by XWdtTb_SelfTest().

#define XWT_GWCSR_GWS1_MASK 0x00000002U

Generic_wdt_interrupt bit.

Referenced by XWdtTb_IsGenericWdtFWExpired().

#define XWT_GWCSR_GWS2_MASK 0x00000004U

Generic_wdt_reset bit.

Referenced by XWdtTb_IsWdtExpired().

#define XWT_GWCSR_OFFSET 0x2000U

Generic Watchdog Control and Status Register Offset.

Referenced by XWdtTb_IsGenericWdtFWExpired(), XWdtTb_IsWdtExpired(), and XWdtTb_SelfTest().

#define XWT_GWCVR0_OFFSET 0x2010U

Generic Watchdog Compare Value Register 0 Offset.

Referenced by XWdtTb_SelfTest().

#define XWT_GWCVR1_OFFSET 0x2014U

Generic Watchdog Compare Value Register 1 Offset.

Referenced by XWdtTb_SelfTest().

#define XWT_GWOR_OFFSET 0x2008U

Generic Watchdog Offset Register Offset.

Referenced by XWdtTb_SelfTest().

#define XWT_GWRR_OFFSET 0x1000U

Generic Watchdog Refresh Register Offset.

Referenced by XWdtTb_RestartWdt(), and XWdtTb_SelfTest().

#define XWT_IDR_OFFSET 0x0030U

Interrupt Disable Register Offset.

#define XWT_IENR_OFFSET 0x002CU

Interrupt Enable Register Offset.

#define XWT_IMR_OFFSET 0x0034U

Interrupt Mask Register Offset.

#define XWT_MWR_AEN_MASK 0x00000002U

Always Enable Mask.

Referenced by XWdtTb_AlwaysEnable().

#define XWT_MWR_MWC_MASK 0x00000001U

Master Write Control Mask.

#define XWT_MWR_OFFSET 0x0000U

Master Write Control Register Offset.

Referenced by XWdtTb_AlwaysEnable(), XWdtTb_ProgramWDTWidth(), and XWdtTb_SelfTest().

#define XWT_SSTWR_OFFSET 0x0014U

Second Sequence Timer Window Configuration Register Offset.

#define XWT_STR_OFFSET 0x001CU

Second Sequence Timer Register Offset.

#define XWT_STR_WWDT_OFFSET 0x0020U

Second Sequence Timer Register Offset for WWDT.

#define XWT_SWR_OFFSET 0x0010U

Second Window Configuration Register Offset.

Referenced by XWdtTb_SelfTest(), and XWdtTb_SetWindowCount().

#define XWT_TBR_OFFSET 0x08U

Timebase Register Offset.

Referenced by XWdtTb_SelfTest().

#define XWT_TFR_OFFSET 0x0024U

Token Feedback Register Offset.

#define XWT_TRR_OFFSET 0x0028U

Token Response Register offset.

#define XWT_TSR0_OFFSET 0x0014U

Task Signature Register 0 Offset.

#define XWT_TSR0_WWDT_OFFSET 0x0018U

Task Signature Register 0 Offset for WWDT.

#define XWT_TSR1_OFFSET 0x0018U

Task Signature Register 1 Offset.

#define XWT_TSR1_WWDT_OFFSET 0x001CU

Task Signature Register 1 Offset for WWDT.

#define XWT_TWCSR0_OFFSET 0x00U

Control/Status Register 0 Offset.

Referenced by WdtTbExample(), WdtTbIntrExample(), XWdtTb_IsWdtExpired(), XWdtTb_LowLevelExample(), and XWdtTb_RestartWdt().

#define XWT_TWCSR1_OFFSET 0x04U

Control/Status Register 1 Offset.

Referenced by XWdtTb_LowLevelExample().

## Enumeration Type Documentation

enum XWdtTb_Event

This typedef contains enumeration of different events in basic mode.

Enumerator
XWDTTB_NO_BAD_EVENT | No bad event.
XWDTTB_RS_KICK_EVENT | Restart kick or disable attempt in first window.
XWDTTB_TSR_MM_EVENT | TSR mismatch.
XWDTTB_SEC_WIN_EVENT | Second window overflow.

## Function Documentation

void XWdtTb_AlwaysEnable | ( | const XWdtTb * | InstancePtr | ) |

This function keeps Window Watchdog Timer always enabled.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  This must be called before Window WDT is enabled. Once Window WDT is enabled, it can only be disabled by applying reset.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_MWR_AEN_MASK, and XWT_MWR_OFFSET.

s32 XWdtTb_CfgInitialize | ( | XWdtTb * | InstancePtr,
|  | const XWdtTb_Config * | CfgPtr,
|  | UINTPTR | EffectiveAddr
| ) |  |

This function initializes the AXI Timebase Watchdog Timer core.

This function must be called prior to using the core. Initialization of the core includes setting up the instance data and ensuring the hardware is in a quiescent state.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.
  CfgPtr | points to the configuration structure associated with the AXI Timebase Watchdog Timer core.
  EffectiveAddr | is the base address of the device. If address translation is being used, then this parameter must reflect the virtual base address. Otherwise, the physical address should be used.

Returns
  - XST_SUCCESS if initialization was successful.
  - XST_DEVICE_IS_STARTED if the device has already been started.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb_Config::DeviceId, XWdtTb::EnableFailCounter, XWdtTb::EnableWinMode, XWdtTb_Config::EnableWinWdt, XWdtTb_Config::IsPl, XWdtTb::IsReady, XWdtTb::IsStarted, XWdtTb_Config::MaxCountWidth, XWdtTb_Config::SstCountWidth, XWdtTb_WriteReg, and XWT_GW_WR_OFFSET.

Referenced by GWdtTbExample(), GWdtTbSelfTestExample(), WdtTbExample(), WdtTbIntrExample(), and WdtTbSelfTestExample().

void XWdtTb_ClearLastEvent | ( | const XWdtTb * | InstancePtr | ) |

This function clears event(s) that present after system reset.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  Event can be cleared by applying reset to the core followed by writing 111. Writing any other pattern has no effect.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_ESR_LBE_MASK, XWT_ESR_OFFSET, XWT_ESR_WSW_MASK, and XWT_ESR_WSW_SHIFT.

void XWdtTb_ClearResetPending | ( | const XWdtTb * | InstancePtr | ) |

This function clears the window watchdog reset pending.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_ESR_OFFSET, and XWT_ESR_WRP_MASK.

void XWdtTb_DisableExtraProtection | ( | const XWdtTb * | InstancePtr | ) |

This function enables unintentional clear of WEN bit.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  This function must be called before Window WDT start/enable or after Window WDT stop/disable.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_OFFSET, and XWT_FCR_WDP_MASK.

void XWdtTb_DisableFailCounter | ( | XWdtTb * | InstancePtr | ) |

This function disables Fail Counter (FC) function.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  This function must be called before Window WDT start/enable or after Window WDT stop/disable.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableFailCounter, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_FCE_MASK, and XWT_FCR_OFFSET.

Referenced by WinWdtIntrExample().

void XWdtTb_DisablePsm | ( | const XWdtTb * | InstancePtr | ) |

This function disables Program Sequence Monitor (PSM) function.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  This function must be called before Window WDT start/enable or after Window WDT stop/disable.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_OFFSET, and XWT_FCR_PSME_MASK.

Referenced by WinWdtIntrExample().

void XWdtTb_DisableSst | ( | const XWdtTb * | InstancePtr | ) |

This function disables Second Sequence Timer (SST) function.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  This function must be called before Window WDT start/enable or after Window WDT stop/disable.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_OFFSET, and XWT_FCR_SSTE_MASK.

Referenced by WinWdtIntrExample().

void XWdtTb_EnableExtraProtection | ( | const XWdtTb * | InstancePtr | ) |

This function provides extra safeguard against unintentional clear of WEN bit.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  This function must be called before Window WDT start/enable or after Window WDT stop/disable.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_OFFSET, and XWT_FCR_WDP_MASK.

void XWdtTb_EnableFailCounter | ( | XWdtTb * | InstancePtr | ) |

This function enables Fail Counter (FC) function.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  - This function must be called before Window WDT start/enable or after Window WDT stop/disable.
  - When fail counter is enabled, reset is generated when fail counter is 7 and another bad event happens.
  - When fail counter is disabled, one bad event triggers reset either immediately when SST is disabled or after SST count delay when SST is enabled.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableFailCounter, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_FCE_MASK, and XWT_FCR_OFFSET.

void XWdtTb_EnablePsm | ( | const XWdtTb * | InstancePtr | ) |

This function enables Program Sequence Monitor (PSM) function.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  - This function must be called before Window WDT start/enable or after Window WDT stop/disable.
  - PSM enables Task Signature Register comparison. When PSM is enabled, core checks and compares the contents of TSR0 and TSR1 registers at the restart kick/disablement of Window WDT in second window. If they match, no effect. If they do not match, reset is generated either immediately when SST is disabled or after SST count delay when SST is enabled.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_OFFSET, and XWT_FCR_PSME_MASK.

void XWdtTb_EnableSst | ( | const XWdtTb * | InstancePtr | ) |

This function enables Second Sequence Timer (SST) function.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  - This function must be called before Window WDT start/enable or after Window WDT stop/disable.
  - SST provides additional time to software by delaying the inevitable window watchdog reset generation by SST count (SC) delay. This is an independent function and can be enabled in any mode w/ or w/o other options.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_OFFSET, and XWT_FCR_SSTE_MASK.

u32 XWdtTb_GetByteCount | ( | const XWdtTb * | InstancePtr | ) |

This function provides byte count value of the selected byte count in the second window configuration.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  Byte count value of the selected byte count in the second window configuration.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWT_FCR_OFFSET, XWT_FCR_SBC_MASK, and XWT_FCR_SBC_SHIFT.

u32 XWdtTb_GetByteSegment | ( | const XWdtTb * | InstancePtr | ) |

This function provides byte segment selection in the second window configuration.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  Byte segment selection value as
  - 0 = Second window byte 0 selected.
  - 1 = Second window byte 1 selected.
  - 2 = Second window byte 2 selected.
  - 3 = Second window byte 3 selected.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWT_FCR_BSS_MASK, XWT_FCR_BSS_SHIFT, and XWT_FCR_OFFSET.

s32 XWdtTb_Initialize | ( | XWdtTb * | InstancePtr,
|  | u16 | DeviceId
| ) |  |

Initialize a specific legacy/window watchdog timer/timebase instance/driver.

This function must be called before other functions of the driver are called.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.
  DeviceId | is the unique id of the device controlled by this XWdtTb instance. Passing in a device id associates the generic XWdtTb instance to a specific device, as chosen by the caller or application developer.

Returns
  - XST_SUCCESS if initialization was successful
  - XST_DEVICE_IS_STARTED if the device has already been started
  - XST_DEVICE_NOT_FOUND if the configuration for device ID was not found

Note
  None.

References XWdtTb::Config, XWdtTb::EnableFailCounter, XWdtTb::EnableWinMode, XWdtTb::IsReady, XWdtTb::IsStarted, and XWdtTb_LookupConfig().

Referenced by WinWdtIntrExample().

void XWdtTb_IntrClear | ( | const XWdtTb * | InstancePtr | ) |

This function clears window watchdog timer interrupt (WINT) bit.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_ESR_OFFSET, XWT_ESR_WINT_MASK, XWT_ESR_WSW_MASK, and XWT_ESR_WSW_SHIFT.

Referenced by WinWdtIntrExample().

u32 XWdtTb_IsGenericWdtFWExpired | ( | const XWdtTb * | InstancePtr | ) |

This function checks if the Generic watchdog timer has First window expired or not.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  - TRUE, if the Generic watchdog timer First window has expired.
  - FALSE if the Generic watchdog is not expired First window.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb_ReadReg, XWT_GWCSR_GWS1_MASK, and XWT_GWCSR_OFFSET.

Referenced by GWdtTbExample().

u32 XWdtTb_IsWdtExpired | ( | const XWdtTb * | InstancePtr | ) |

This function checks if the legacy watchdog timer has expired or window watchdog timer either in second window or not in second window.

This function is used for polled mode in legacy watchdog timer.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  - TRUE, if the legacy watchdog timer has expired or window watchdog timer is not in second window.
  - FALSE if the legacy watchdog is not expired or window watchdog is in second window.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_Config::IsPl, XWdtTb::IsReady, XWdtTb_ReadReg, XWT_CSR0_WDS_MASK, XWT_CSR0_WRS_MASK, XWT_ESR_OFFSET, XWT_ESR_WSW_MASK, XWT_ESR_WSW_SHIFT, XWT_GWCSR_GWS2_MASK, XWT_GWCSR_OFFSET, and XWT_TWCSR0_OFFSET.

Referenced by GWdtTbExample(), and WdtTbExample().

XWdtTb_Config* XWdtTb_LookupConfig | ( | u16 | DeviceId | ) |

This function returns a reference to an XWdtTb_Config structure based on the core id, DeviceId.

The return value will refer to an entry in the device configuration table defined in the xwdttb_g.c file.

Parameters

  DeviceId | is the unique core ID of the XWdtTb core for the lookup operation.

Returns
  XWdtTb_LookupConfig returns a reference to a config record in the configuration table (in xwdttb_g.c) corresponding to DeviceId, or NULL if no match is found.

Note
  None.

Referenced by GWdtTbExample(), GWdtTbSelfTestExample(), WdtTbExample(), WdtTbIntrExample(), WdtTbSelfTestExample(), and XWdtTb_Initialize().

u32 XWdtTb_ProgramWDTWidth | ( | const XWdtTb * | InstancePtr,
|  | u32 | width
| ) |  |

This function programs the width of Watchdog Timer.

Parameters

  InstancePtr | - InstancePtr is a pointer to the XWdtTb instance to be worked on. width - width of the Watchdog Timer.

Returns
  - XST_SUCESS, if window mode is disabled and the width is programmed correctly.
  - XST_FAILURE, if Window mode is enabled or if the width is not in the range of 8-31

Note
  - This function is applicable only when the window mode is disabled.
  - This function should be called before starting the timer. Valid values for the width are 8-31. Programming any other value returns failure.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_WriteReg, and XWT_MWR_OFFSET.

void XWdtTb_RestartWdt | ( | const XWdtTb * | InstancePtr | ) |

This function restarts the legacy or window watchdog timer.

An application needs to call this function periodically to keep the timer from asserting the reset output.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_Config::IsPl, XWdtTb::IsReady, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_CSR0_WDS_MASK, XWT_CSR0_WRS_MASK, XWT_ESR_OFFSET, XWT_ESR_WSW_MASK, XWT_GWRR_OFFSET, and XWT_TWCSR0_OFFSET.

Referenced by GWdtTbExample(), and WdtTbExample().

s32 XWdtTb_SelfTest | ( | const XWdtTb * | InstancePtr | ) |

This function runs a self-test on the timebase or window if enabled.

Timebase test verifies that the timebase is incrementing. The watchdog timer is not tested due to the time required to wait for the watchdog timer to expire. The time consumed by this test is dependent on the system clock and the configuration of the dividers in for the input clock of the timebase.

Window test verifies that the windowing feature does not generate bad event after enabling window feature with first and second window count. It disables window feature immediately.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  - XST_SUCCESS if self-test was successful.
  - XST_WDTTB_TIMER_FAILED if the timebase is not incrementing.
  - XST_FAILURE if self-test was failed.

Note
  None.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_Config::IsPl, XWdtTb::IsReady, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_ESR_LBE_MASK, XWT_ESR_LBE_SHIFT, XWT_ESR_OFFSET, XWT_ESR_WEN_MASK, XWT_ESR_WSW_MASK, XWT_FWR_OFFSET, XWT_GWCSR_GWEN_MASK, XWT_GWCSR_OFFSET, XWT_GWCVR0_OFFSET, XWT_GWCVR1_OFFSET, XWT_GWOR_OFFSET, XWT_GWRR_OFFSET, XWT_MWR_OFFSET, XWT_SWR_OFFSET, and XWT_TBR_OFFSET.

Referenced by GWdtTbExample(), GWdtTbSelfTestExample(), WdtTbExample(), WdtTbIntrExample(), WdtTbSelfTestExample(), and WinWdtIntrExample().

void XWdtTb_SetByteCount | ( | const XWdtTb * | InstancePtr,
|  | u32 | ByteCount
| ) |  |

This function sets byte count to determine the interrupt assertion point in the second window configuration.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.
  ByteCount | specifies the selected byte count value to be set in the second window configuration.

Returns
  None.

Note
  - This function must be called before Window WDT start/enable or after Window WDT stop/disable.
  - This function must be used along with XWdtTb_SetByteSegment.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_OFFSET, XWT_FCR_SBC_MASK, and XWT_FCR_SBC_SHIFT.

Referenced by WinWdtIntrExample().

void XWdtTb_SetByteSegment | ( | const XWdtTb * | InstancePtr,
|  | u32 | ByteSegment
| ) |  |

This function sets byte segment selection to determine the interrupt assertion point in the second window configuration.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.
  ByteSegment | specifies the byte segment selected. 0 = Second window byte 0 selected. 1 = Second window byte 1 selected. 2 = Second window byte 2 selected. 3 = Second window byte 3 selected.

Returns
  None.

Note
  - This function must be called before Window WDT start/enable or after Window WDT stop/disable.
  - This function must be used along with XWdtTb_SetByteCount.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_ReadReg, XWdtTb_WriteReg, XWT_FCR_BSS_MASK, XWT_FCR_BSS_SHIFT, and XWT_FCR_OFFSET.

Referenced by WinWdtIntrExample().

void XWdtTb_SetWindowCount | ( | const XWdtTb * | InstancePtr,
|  | u32 | FirstWinCount,
|  | u32 | SecondWinCount
| ) |  |

This function sets the count value for the first and second window.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.
  FirstWinCount | specifies the first window count value.
  SecondWinCount | specifies the second window count value.

Returns
  None.

Note
  This function must be called before Window WDT start/enable or after Window WDT stop/disable.
  - For first window, it is recommended that minimum non-zero value should be 15 or more.
  - For second window, minimum value should be sufficiently large to complete required AXILite write transactions at system level.
  - Setting second window count value to zero causes wrong configuration and disables Window WDT feature by clearing WEN bit irrespective of WDP settings.

References XWdtTb_Config::BaseAddr, XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_WriteReg, XWT_FWR_OFFSET, and XWT_SWR_OFFSET.

Referenced by WinWdtIntrExample().

void XWdtTb_Start | ( | XWdtTb * | InstancePtr | ) |

This function starts the legacy or window watchdog timer.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  None.

Note
  - For legacy, the Timebase is reset to 0 when the Watchdog Timer is started. The Timebase is always incrementing.
  - For window, this generates first kick and starts the first window. This step auto clears MWC bit to make address space read only.

References XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_Config::IsPl, and XWdtTb::IsReady.

Referenced by GWdtTbExample(), WdtTbExample(), WdtTbIntrExample(), and WinWdtIntrExample().

s32 XWdtTb_Stop | ( | XWdtTb * | InstancePtr | ) |

This function disables the legacy or window watchdog timer.

It is the caller's responsibility to disconnect the interrupt handler of the watchdog timer from the interrupt source, typically an interrupt controller, and disable the interrupt in the interrupt controller.

Parameters

  InstancePtr | is a pointer to the XWdtTb instance to be worked on.

Returns
  - XST_SUCCESS if the legacy/window watchdog was stopped successfully.
  - XST_NO_FEATURE if disable is not supported in legacy watchdog timer.
  - XST_FAILURE if the window watchdog timer cannot be stopped.

Note
  - For legacy, the hardware configuration controls this functionality. If it is not allowed by the hardware the failure will be returned and the timer will continue without interruption.

References XWdtTb::Config, XWdtTb::EnableWinMode, XWdtTb_Config::IsPl, and XWdtTb::IsReady.

Referenced by GWdtTbExample(), GWdtTbSelfTestExample(), WdtTbExample(), WdtTbIntrExample(), and WinWdtIntrExample().